"""
Django settings for ottb project.

Generated by 'django-admin startproject' using Django 1.11.8.

For more information on this file, see
https://docs.djangoproject.com/en/1.11/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.11/ref/settings/
"""

from __future__ import absolute_import, unicode_literals

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
import os

PROJECT_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
BASE_DIR = os.path.dirname(PROJECT_DIR)

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.11/howto/deployment/checklist/


# Application definition

INSTALLED_APPS = [
    'wagtail_modeltranslation',
    'wagtail_modeltranslation.makemigrations',
    'base',
    'home',
    'blog',
    'feed',
    'about_us',
    'cookie_consent',
    'roadbook',
    'gps_track',
    'comment',

    'wagtail.contrib.settings',
    'wagtail.contrib.forms',
    'wagtail.contrib.redirects',
    'wagtail.embeds',
    'wagtail.sites',
    'wagtail.users',
    'wagtail.snippets',
    'wagtail.documents',
    'wagtail.images',
    'wagtail.search',
    'wagtail.admin',
    'wagtail.core',
    'wagtail.contrib.routable_page',

    'compressor',
    'modelcluster',
    'taggit',

    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'rest_framework',
    'analytical',
    'leaflet',
    'wagtailmetadata',
]

MIDDLEWARE = [
    'django.middleware.cache.UpdateCacheMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.auth.middleware.SessionAuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'django.middleware.security.SecurityMiddleware',
    'django.middleware.locale.LocaleMiddleware',

    'wagtail.core.middleware.SiteMiddleware',
    'wagtail.contrib.redirects.middleware.RedirectMiddleware',
    'django.middleware.cache.FetchFromCacheMiddleware',
]

ROOT_URLCONF = 'ottb.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [
            os.path.join(PROJECT_DIR, 'templates'),
        ],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
                'wagtail.contrib.settings.context_processors.settings',
            ],
        },
    },
]

WSGI_APPLICATION = 'ottb.wsgi.application'

# Internationalization
# https://docs.djangoproject.com/en/1.11/topics/i18n/

LANGUAGE_CODE = 'en-us'

LANGUAGES = (
    ('en', 'English'),
    ('fr', 'Français'),
)

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.11/howto/static-files/

STATICFILES_FINDERS = [
    'django.contrib.staticfiles.finders.FileSystemFinder',
    'django.contrib.staticfiles.finders.AppDirectoriesFinder',
    'compressor.finders.CompressorFinder',
]

STATICFILES_DIRS = [
    os.path.join(PROJECT_DIR, 'static'),
]

STATIC_ROOT = os.path.join(BASE_DIR, 'static')
STATIC_URL = '/static/'

MEDIA_ROOT = os.path.join(BASE_DIR, 'media')
MEDIA_URL = '/media/'

# Wagtail settings

WAGTAIL_SITE_NAME = "1 Tipi 2 Bicycles"

WAGTAIL_AUTO_UPDATE_PREVIEW = True

# Base URL to use when referring to full URLs within the Wagtail admin backend -
# e.g. in notification emails. Don't include '/admin' or a trailing slash
BASE_URL = 'http://1tipi2bicycl.es'

# Compressor setings
COMPRESS_PRECOMPILERS = (
    # Sass compiler
    ('text/x-scss', 'django_libsass.SassCompiler'),
    ('text/x-sass', 'django_libsass.SassCompiler'),
)

COMPRESS_CSS_FILTERS = (
    # Default settings of CSS compressor
    'compressor.filters.css_default.CssAbsoluteFilter',
    # Postcss filter to use autoprefixer
    'compressor_postcss.PostCSSFilter',
)

COMPRESS_POSTCSS_PLUGINS = (
    # The only thing we need from postcss
    'autoprefixer',
)

# Using postcss binary from within the project installed using yarn
COMPRESS_POSTCSS_BINARY = os.path.join(BASE_DIR, '../node_modules/postcss-cli/bin/postcss')

LEAFLET_CONFIG = {
    'DEFAULT_CENTER': (-4.718075, -43.0635756),
    'DEFAULT_ZOOM': 2,
    'TILES': [
        ('Esri WorldTopoMap',
         'https://server.arcgisonline.com/ArcGIS/rest/services/World_Topo_Map/MapServer/tile/{z}/{y}/{x}', {
             'attribution': ('Tiles &copy; Esri &mdash; Source: Esri, HERE, Garmin, Intermap, INCREMENT P, GEBCO, ',
                             'USGS, FAO, NPS, NRCAN, GeoBase, IGN, Kadaster NL, Ordnance Survey, Esri Japan, METI, ',
                             'Esri China (Hong Kong), swisstopo, MapmyIndia, © OpenStreetMap contributors, ',
                             'GIS User Community'),
         },),
        ('Esri WorldStreetMap',
         'https://server.arcgisonline.com/ArcGIS/rest/services/World_Street_Map/MapServer/tile/{z}/{y}/{x}', {
             'attribution': ('Tiles &copy; Esri &mdash; Source: Esri, HERE, Garmin, USGS, Intermap, INCREMENT P, ',
                             'NRCAN, Esri Japan, METI, Esri China (Hong Kong), Esri (Thailand), MapmyIndia, ',
                             '© OpenStreetMap contributors, and the GIS User Community'),
         },),
        ('Terrain', 'https://stamen-tiles-{s}.a.ssl.fastly.net/terrain/{z}/{x}/{y}.{ext}', {
            'attribution': ('Map tiles by <a href="http://stamen.com">Stamen Design</a>, ',
                            '<a href="http://creativecommons.org/licenses/by/3.0">CC BY 3.0</a> &mdash; Map data ',
                            '&copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a>'),
            'subdomains': 'abcd',
            'minZoom': 0,
            'maxZoom': 18,
            'ext': 'png',
        },),
        ('Watercolor', 'https://stamen-tiles-{s}.a.ssl.fastly.net/watercolor/{z}/{x}/{y}.{ext}', {
            'attribution': ('Map tiles by <a href="http://stamen.com">Stamen Design</a>, ',
                            '<a href="http://creativecommons.org/licenses/by/3.0">CC BY 3.0</a> &mdash; Map data ',
                            '&copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a>'),
            'subdomains': 'abcd',
            'minZoom': 1,
            'maxZoom': 16,
            'ext': 'png',
        },),
        ('OSM France', 'https://{s}.tile.openstreetmap.fr/osmfr/{z}/{x}/{y}.{ext}', {
            'attribution': ('&copy; Openstreetmap France | &copy; <a href="http://www.openstreetmap.org/copyright">',
                            'OpenStreetMap</a>'),
            'maxZoom': 20,
            'ext': 'png',
        },),
    ],
}

# Cache
CACHE_MIDDLEWARE_KEY_PREFIX = '1tipi2bicycles'
